import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.imageio.*;
import java.awt.geom.*;

/**
 * plNX
 */
public class ARPanel extends JPanel {

	/** tF[Y */
	private final int				PHASE_TITLE			= 0;
	private final int				PHASE_GAMESTART		= 1;
	private final int				PHASE_GAME			= 2;
	private final int				PHASE_CLASH			= 3;
	private final int				PHASE_GAMEOVER		= 4;

	/** tHg */
	private final Font				FONT_TEXT			= new Font("lr SVbN", Font.PLAIN, 16);
	private final Font				FONT_GAMEOVER		= new Font("lr SVbN", Font.BOLD, 24);

	/** tF[Y */
	private		int					phase				= 0;

	/** XRA */
	private		int					score				= 0;
	private		int					scoreHigh			= 30000;

	/** L[A_v^[ */
	private		MGKeyAdapter		mgka				= null;

	/** L[ĂԈꗗ */
	private		boolean[]			keyPressTbl			= null;

	/** wiPʒu */
	private		int					yBackground1		= 0;
	/** wiQʒu */
	private		int					yBackground2		= 0;

	/** FDʒu */
	private		int					x					= 0;
	private		int					y					= 0;

	/** x */
	private		int					mx					= 0;
	private		int					my					= 0;

	/** FĎ */
	private		int					muki				= 0;

	/** fʒu */
	private		int[]				xAsteroids			= new int[100];
	private		int[]				yAsteroids			= new int[100];

	/** fx */
	private		int[]				mxAsteroids			= new int[100];
	private		int[]				myAsteroids			= new int[100];

	/** fpx */
	private		int[]				angleAsteroids		= new int[100];
	private		int[]				velocityAsteroids	= new int[100];

	/** f傫 */
	private		int[]				widthAsteroids		= new int[100];

	/** wiP */
	private		BufferedImage		imageBackground1	= null;
	/** wiQ */
	private		BufferedImage		imageBackground2	= null;

	/** FD */
	private		BufferedImage[]		imageShips			= null;

	/** f */
	private		BufferedImage		imageAsteroid		= null;

	/** ^C}[ */
	private		java.util.Timer		timerThis			= null;

	/** oߎ */
	private		int					time				= 0;

	/** ԁi낢j */
	private		int					timeWork			= 0;

	/**
	 * RXgN^
	 */
	public ARPanel() {

		// X[p[NXĂяo
		super();

		try{

			// plTCY
			super.setPreferredSize(new Dimension(800, 800));
			// CAEgݒ
			super.setLayout(null);

			// L[󋵈ꗗ𐶐
			keyPressTbl = new boolean[256];

			// wiPǂݍ
			InputStream isBackground1 = this.getClass().getResourceAsStream("imageBackground1.gif");
			imageBackground1 = ImageIO.read(isBackground1);
			isBackground1.close();

			// wiQǂݍ
			InputStream isBackground2 = this.getClass().getResourceAsStream("imageBackground2.gif");
			imageBackground2 = ImageIO.read(isBackground2);
			isBackground2.close();

			// FDǂݍ
			imageShips = new BufferedImage[3];
			InputStream is0 = this.getClass().getResourceAsStream("imageShip0.gif");
			imageShips[0] = ImageIO.read(is0);
			is0.close();

			InputStream is1 = this.getClass().getResourceAsStream("imageShipR.gif");
			imageShips[1] = ImageIO.read(is1);
			is1.close();

			InputStream is2 = this.getClass().getResourceAsStream("imageShipL.gif");
			imageShips[2] = ImageIO.read(is2);
			is1.close();

			// fǂݍ
			InputStream isA = this.getClass().getResourceAsStream("imageAsteroid.gif");
			imageAsteroid = ImageIO.read(isA);
			isA.close();

			// L[A_v^𐶐
			mgka = new MGKeyAdapter();
			// plɃL[Xi[ǉ
			this.addKeyListener(mgka);

			// 
			init();

			// ^C}[𐶐
			timerThis = new java.util.Timer();

			// ^C}[X^[g
			timerThis.scheduleAtFixedRate(new TimerActionListener(), 1000l, 8l);

			// Q[X^[g
			start();

		}catch(Exception ex){
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, "ERROR : " + ex.toString());
		}

	} // end ARPanel

	/**
	 * 
	 */
	public void init(){

		// 
		time = 0;

		// XRA
		score = 0;

		// ʒu
		x = 384;
		y = 640;

		mx = 0;
		my = 0;

		// f
		for(int i = 0; i < 100; i++){
			yAsteroids[i] = -9999;
		}

	} // end init

	/**
	 * Q[X^[g
	 */
	public void start(){

		phase = PHASE_GAME;

	}

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// wiPړ^C~O
		if(time % 5 == 0){

			// wii߂
			yBackground1++;
			if(yBackground1 > 0){
				yBackground1 = -800;
			}

		} // end if wiPړ^C~O

		// wiQړ^C~O
		if(time % 2 == 0){

			// wii߂
			yBackground2 = yBackground2 + 1;
			if(yBackground2 > 0){
				yBackground2 = -800;
			}

		} // end if wiPړ^C~O

		// FDړ^C~O
		if(time % 6 == 0){

			// 
			muki = 0;

			// ̏ꍇA
			if(isKeyCodePressed(KeyEvent.VK_LEFT)){
				// ɂ
				muki = 2;
				// 
				mx = mx - 1;
			}

			// ȄꍇA
			if(isKeyCodePressed(KeyEvent.VK_RIGHT)){
				// ɂ
				muki = 1;
				// 
				mx = mx + 1;
			}

		} // end if FDړ^C~O

		// ړ^C~O
		if(time % 2 == 0){

			// Q[̏ꍇA
			if(phase == PHASE_GAME){

				// XRA{10
				score = score + 10;

				// nCXRA𒴂ꍇA
				if(score > scoreHigh){
					// nCXRAXV
					scoreHigh = score;
				}

				// ړ
				x = x + mx;

				// ԍɗꍇA
				if(x < 0){
					x = 0;
					mx = 0;

				// ԉEɗꍇA
				}else if(x > this.getWidth() - 32){
					x = this.getWidth() - 32;
					mx = 0;
				}

			// ˂ĂꍇA
			}else if(phase == PHASE_CLASH){

				// ԁ{P
				timeWork++;

				// ʒuړ
				x = x + mx;
				y = y + my;

				// Qbo
				if(timeWork == 120){

					// Ԃ
					timeWork = 0;

					// Q[I[o[
					phase = PHASE_GAMEOVER;

				}

			// Q[I[o[̏ꍇA
			}else if(phase == PHASE_GAMEOVER){

				// ԁ{P
				timeWork++;

				// Tbo
				if(timeWork == 300){

					// 
					init();

					// Q[X^[g
					start();

				}

			}

			// fH
			if(Math.random() < 0.02){

				// 󂢂Ă鏬fT
				int pos = -1;
				for(int i = 0; i < 100; i++){
					if(yAsteroids[i] == -9999){
						pos = i;
						break;
					}
				}

				// f
				widthAsteroids[pos] = (int)(Math.random() * 150) + 30;
				xAsteroids[pos] = (int)(Math.random() * 800);
				yAsteroids[pos] = -widthAsteroids[pos];
				mxAsteroids[pos] = 3 - (int)(Math.random() * 6);
				myAsteroids[pos] = 5 + (int)(Math.random() * 5);
				angleAsteroids[pos] = (int)(Math.random() * 360);
				velocityAsteroids[pos] = (int)(Math.random() * 10);

			} // end if fH

			// fꗗA[v
			for(int i = 0; i < 100; i++){

				// f݂H
				if(yAsteroids[i] != -9999){

					// ړ
					xAsteroids[i] = xAsteroids[i] + mxAsteroids[i];
					yAsteroids[i] = yAsteroids[i] + myAsteroids[i];
					angleAsteroids[i] = angleAsteroids[i] + velocityAsteroids[i];

					// Փ˔
					if(xAsteroids[i] < x + 10 && x + 32 - 10 < xAsteroids[i] + widthAsteroids[i] &&
						yAsteroids[i] < y + 20 && y + 40 - 20 < yAsteroids[i] + widthAsteroids[i]){

						// FD
						mx = mxAsteroids[i];
						my = myAsteroids[i];

						// Ԃ
						timeWork = 0;

						// 
						phase = PHASE_CLASH;

					}

					// Oɏo
					if(yAsteroids[i] > 800){
						// f폜
						yAsteroids[i] = -9999;
					}

				} // f݂H

			} // end for fꗗA[v

		} // end if ړ^C~O

		// ĕ`^C~O
		if(time % 2 == 1){

			// ĕ`
			repaint();

		}

	} // end run

	/**
	 * `惁\bh
	 * <pre>
	 * yCgKvƂɂ̃\bhĂяo܂B
	 * </pre>
	 */
	public void paint(Graphics g){

		// Graphics2D擾
		Graphics2D g2 = (Graphics2D) g;

		// Transform擾
		AffineTransform af = new AffineTransform();

		// wiP`悷
		g.drawImage(imageBackground1, 0, yBackground1, 800, 800, this);
		g.drawImage(imageBackground1, 0, yBackground1 + 800, 800, 800, this);

		// wiQ`悷
		g.drawImage(imageBackground2, 0, yBackground2, 800, 800, this);
		g.drawImage(imageBackground2, 0, yBackground2 + 800, 800, 800, this);

		// fꗗA[v
		for(int i = 0; i < 100; i++){

			// f݂H
			if(yAsteroids[i] != -9999){

				// ]vZ
				double radAsteroid = angleAsteroids[i] * Math.PI/180;
				// \ʒuvZ
				double xAsteroid = (double)xAsteroids[i] + widthAsteroids[i] / 2;
				double yAsteroid = (double)yAsteroids[i] + widthAsteroids[i] / 2;

				// ]A\ʒu肷
				af.setToRotation(radAsteroid, xAsteroid, yAsteroid);

				// Transformݒ肷
				g2.setTransform(af);

				// f`悷
				g2.drawImage(imageAsteroid, xAsteroids[i], yAsteroids[i], widthAsteroids[i], widthAsteroids[i], this);

			} // f݂H

		} // end for fꗗA[v

		// ]ƕ\ʒu߂
		af.setToRotation(0d, 0d, 0d);

		// Transformݒ肷
		g2.setTransform(af);

		// FD`悷
		g2.drawImage(imageShips[muki], x, y, 32, 40, this);

		// F̐ݒ
		g2.setColor(Color.lightGray);

		// tHg̐ݒ
		g2.setFont(FONT_TEXT);

		// XRA̕\
		g2.drawString("SCORE  " + score, 100, 20);

		// nCXRA̕\
		g2.drawString("HIGH-SCORE  " + scoreHigh, 500, 20);

		// Q[I[o[̏ꍇA
		if(phase == PHASE_GAMEOVER){
			// tHg̐ݒ
			g2.setFont(FONT_GAMEOVER);
			// GAME OVER\
			g2.drawString("f`ld@nudq", 300, 350);
		}

	} // end paint

	/**
	 * L[ǂ`FbN
	 */
	public boolean isKeyCodePressed(int keyCode){

		return keyPressTbl[keyCode];

	} // end isKeyCodePressed

	/**
	 * L[A_v^[NX
	 */
	private class MGKeyAdapter extends KeyAdapter {

		/**
		 * L[ƂɌĂ΂܂
		 */
		@Override
		public void keyPressed(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = true;
			}
		}

		/**
		 * L[𗣂ƂɌĂ΂܂
		 */
		@Override
		public void keyReleased(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = false;
			}
		}

	} // MGKeyAdapter

	/**
	 * ^C}[NX
	 */
	private class TimerActionListener extends TimerTask {

		/**
		 * s
		 */
		@Override
		public void run(){

			// s\bhĂяo
			ARPanel.this.run();

		} // end actionPerformed

	} // end TimerActionListener

}
